precision highp float; // 必须要用highp, 用mediump会导致部分机型下导出输出画面模糊
#if __VERSION__ >= 300
    layout (location = 0) out vec4 FragColor;
    in vec2 varyTexCoord;
#else
    varying vec2 varyTexCoord;
#endif

uniform sampler2D sampleTexture;
uniform mat4 colorMat;
uniform float offset;
const float UV_HEIGHT = 1.0 / 3.0;
const float U_HEIGHT = 1.0 / 6.0;

void main() {
   mat4 cm = inverse(colorMat);
   if (varyTexCoord.y >= UV_HEIGHT) {
       vec2 texCoord = vec2(varyTexCoord.x, (varyTexCoord.y - UV_HEIGHT) * 3.0 / 2.0);
       vec4 color0 = texture(sampleTexture, texCoord);
       vec4 color1 = texture(sampleTexture, texCoord + vec2(offset * 1.0, 0.0));
       vec4 color2 = texture(sampleTexture, texCoord + vec2(offset * 2.0, 0.0));
       vec4 color3 = texture(sampleTexture, texCoord + vec2(offset * 3.0, 0.0));
       color0.a = 1.0;color1.a = 1.0;color2.a = 1.0;color3.a = 1.0;
       float y0 = dot(cm[0], color0);
       float y1 = dot(cm[0], color1);
       float y2 = dot(cm[0], color2);
       float y3 = dot(cm[0], color3);
       FragColor = vec4(y0, y1, y2, y3);
   } else {
       vec2 texCoord = vec2(varyTexCoord.x, varyTexCoord.y * 3.0);
       vec4 color0 = texture(sampleTexture, texCoord);
       vec4 color1 = texture(sampleTexture, texCoord + vec2(offset * 1.0, 0.0));
       vec4 color2 = texture(sampleTexture, texCoord + vec2(offset * 2.0, 0.0));
       vec4 color3 = texture(sampleTexture, texCoord + vec2(offset * 3.0, 0.0));
       color0.a = 1.0;color1.a = 1.0;color2.a = 1.0;color3.a = 1.0;
       float u0 = dot(cm[1], color0);
       float v0 = dot(cm[2], color1);
       float u1 = dot(cm[1], color2);
       float v1 = dot(cm[2], color3);
       FragColor = vec4(u0, v0, u1, v1);
   }
}