precision highp float;
#if __VERSION__ >= 300
    layout (location = 0) out vec4 FragColor;
    in vec2 varyTexCoord;
#else
    varying vec2 varyTexCoord;
#endif

uniform sampler2D sampleTexture;

void main() {
#if __VERSION__ >= 300
   vec4 color = texture(sampleTexture, varyTexCoord);
   FragColor = vec4(color.rgb, 1.0);
#else
   vec4 color = texture2D(sampleTexture, varyTexCoord);
   gl_FragColor = vec4(color.rgb, 1.0);
#endif
}