precision highp float;
#if __VERSION__ >= 300
    layout (location = 0) in vec2 aPosition;
    out vec2 varyCoord;
#else
    attribute vec2 aPosition;
    varying vec2 varyCoord;
#endif

uniform mat4 model;
uniform mat4 view;
uniform mat4 projection;

void main() {
    gl_Position = projection * view *  model * vec4(aPosition, 0.0, 1.0);
    varyCoord = gl_Position.xy;
}